#include "global.h"
#include <csignal>
#include <iostream>
#include <openssl/ssl.h>
void safe_exit(int code) {
  switch (code) {
  case SIGTERM:
    std::cerr << "\nreceived SIGTERM exiting...\n";
    break;
  case SIGINT:
    std::cerr << "\nreceived SIGINT exiting...\n";
    break;
  case SIGQUIT:
    std::cerr << "\nreceived SIGQUIT exiting...\n";
    break;
  case SIGHUP:
    std::cerr << "\nreceived SIGHUP exiting...\n";
    break;

  case SIGSEGV:
    std::cerr << "\nreceived SIGSEGV(segmentation fault) exiting...\nIf this "
                 "repeats please report it as a bug\n";
    break;

  default:
    break;
  }
  SSL_CTX_free(ctx);
  close(sockfd);
  exit(code);
}